Bug 1191087 (CVE-2014-9665)

Summary: CVE-2014-9665 freetype: integer overflow leading to heap-based buffer overflow in Load_SBit_Png()
Product: [Other] Security Response Reporter: Vasyl Kaigorodov <vkaigoro>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED NOTABUG QA Contact:
Severity: high Docs Contact:
Priority: high    
Version: unspecifiedCC: behdad, fonts-bugs, kevin, mkasik
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: freetype 2.5.4 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-02-20 23:12:59 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1191099    
Bug Blocks: 1191102    

Description Vasyl Kaigorodov 2015-02-10 12:51:30 UTC
Common Vulnerabilities and Exposures assigned CVE-2014-9665 to the following issue:

The Load_SBit_Png function in sfnt/pngshim.c in FreeType before 2.5.4 does not
restrict the rows and pitch values of PNG data, which allows remote attackers to
cause a denial of service (integer overflow and heap-based buffer overflow) or
possibly have unspecified other impact by embedding a PNG file in a .ttf font
file.

http://code.google.com/p/google-security-research/issues/detail?id=168
http://git.savannah.gnu.org/cgit/freetype/freetype2.git/commit/?id=54abd22891bd51ef8b533b24df53b3019b5cee81
http://git.savannah.gnu.org/cgit/freetype/freetype2.git/commit/?id=b3500af717010137046ec4076d1e1c0641e33727

Comment 1 Vasyl Kaigorodov 2015-02-10 12:56:53 UTC
Created freetype tracking bugs for this issue:

Affects: fedora-all [bug 1191099]

Comment 2 Fedora Update System 2015-02-19 18:00:56 UTC
freetype-2.5.3-15.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 3 Fedora Update System 2015-02-20 08:30:53 UTC
freetype-2.5.0-9.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 4 Tomas Hoger 2015-02-20 23:12:59 UTC
Upstream bug is:
https://savannah.nongnu.org/bugs/?43658

Issue was fixed upstream in 2.5.4.

Support for bitmaps embedded in SFNT fonts was introduced in upstream version 2.5.  Additionally, the affected code was added in 2.5.1 via:

http://git.savannah.gnu.org/cgit/freetype/freetype2.git/commit/?id=01705395

The freetype packages in Red Hat Enterprise Linux 7 and earlier are based on older unaffected upstream versions.

Statement:

Not vulnerable. This issue did not affect the versions of freetype as shipped with Red Hat Enterprise Linux 5, 6 and 7.